---
title: llarp::PubKey

---

# llarp::PubKey





Inherits from [llarp::AlignedBuffer< PUBKEYSIZE >](Classes/structllarp_1_1AlignedBuffer.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[PubKey](Classes/structllarp_1_1PubKey.md#function-pubkey)**() =default |
| | **[PubKey](Classes/structllarp_1_1PubKey.md#function-pubkey)**(const byte_t * ptr) |
| | **[PubKey](Classes/structllarp_1_1PubKey.md#function-pubkey)**(const Data & data) |
| | **[PubKey](Classes/structllarp_1_1PubKey.md#function-pubkey)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md)< SIZE > & other) |
| std::string | **[ToString](Classes/structllarp_1_1PubKey.md#function-tostring)**() const |
| bool | **[FromString](Classes/structllarp_1_1PubKey.md#function-fromstring)**(const std::string & str) |
| | **[operator RouterID](Classes/structllarp_1_1PubKey.md#function-operator-routerid)**() const |
| [PubKey](Classes/structllarp_1_1PubKey.md) & | **[operator=](Classes/structllarp_1_1PubKey.md#function-operator=)**(const byte_t * ptr) |

## Additional inherited members

**Public Types inherited from [llarp::AlignedBuffer< PUBKEYSIZE >](Classes/structllarp_1_1AlignedBuffer.md)**

|                | Name           |
| -------------- | -------------- |
| using std::array< byte_t, sz > | **[Data](Classes/structllarp_1_1AlignedBuffer.md#using-data)**  |

**Public Functions inherited from [llarp::AlignedBuffer< PUBKEYSIZE >](Classes/structllarp_1_1AlignedBuffer.md)**

|                | Name           |
| -------------- | -------------- |
| | **[AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md#function-alignedbuffer)**() =default |
| | **[AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md#function-alignedbuffer)**(const byte_t * data) |
| constexpr | **[AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md#function-alignedbuffer)**(const Data & buf) |
| constexpr | **[AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md#function-alignedbuffer)**(Data && buf) |
| constexpr [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md)< sz > | **[operator~](Classes/structllarp_1_1AlignedBuffer.md#function-operator~)**() const<br>bitwise NOT  |
| constexpr bool | **[operator==](Classes/structllarp_1_1AlignedBuffer.md#function-operator==)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) const |
| constexpr bool | **[operator!=](Classes/structllarp_1_1AlignedBuffer.md#function-operator!=)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) const |
| constexpr bool | **[operator<](Classes/structllarp_1_1AlignedBuffer.md#function-operator<)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) const |
| constexpr bool | **[operator>](Classes/structllarp_1_1AlignedBuffer.md#function-operator>)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) const |
| constexpr bool | **[operator<=](Classes/structllarp_1_1AlignedBuffer.md#function-operator<=)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) const |
| constexpr bool | **[operator>=](Classes/structllarp_1_1AlignedBuffer.md#function-operator>=)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) const |
| constexpr [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) | **[operator^](Classes/structllarp_1_1AlignedBuffer.md#function-operator^)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) const |
| constexpr [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & | **[operator^=](Classes/structllarp_1_1AlignedBuffer.md#function-operator^=)**(const [AlignedBuffer](Classes/structllarp_1_1AlignedBuffer.md) & other) |
| byte_t & | **[operator[]](Classes/structllarp_1_1AlignedBuffer.md#function-operator[])**(size_t idx) |
| const byte_t & | **[operator[]](Classes/structllarp_1_1AlignedBuffer.md#function-operator[])**(size_t idx) const |
| constexpr void | **[Fill](Classes/structllarp_1_1AlignedBuffer.md#function-fill)**(byte_t f) |
| constexpr Data & | **[as_array](Classes/structllarp_1_1AlignedBuffer.md#function-as-array)**() |
| constexpr const Data & | **[as_array](Classes/structllarp_1_1AlignedBuffer.md#function-as-array)**() const |
| constexpr byte_t * | **[data](Classes/structllarp_1_1AlignedBuffer.md#function-data)**() |
| constexpr const byte_t * | **[data](Classes/structllarp_1_1AlignedBuffer.md#function-data)**() const |
| bool | **[IsZero](Classes/structllarp_1_1AlignedBuffer.md#function-iszero)**() const |
| void | **[Zero](Classes/structllarp_1_1AlignedBuffer.md#function-zero)**() |
| virtual void | **[Randomize](Classes/structllarp_1_1AlignedBuffer.md#function-randomize)**() |
| constexpr Data::iterator | **[begin](Classes/structllarp_1_1AlignedBuffer.md#function-begin)**() |
| constexpr Data::iterator | **[end](Classes/structllarp_1_1AlignedBuffer.md#function-end)**() |
| constexpr Data::const_iterator | **[begin](Classes/structllarp_1_1AlignedBuffer.md#function-begin)**() const |
| constexpr Data::const_iterator | **[end](Classes/structllarp_1_1AlignedBuffer.md#function-end)**() const |
| constexpr std::string_view | **[ToView](Classes/structllarp_1_1AlignedBuffer.md#function-toview)**() const |
| bool | **[FromBytestring](Classes/structllarp_1_1AlignedBuffer.md#function-frombytestring)**([llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) |
| bool | **[BEncode](Classes/structllarp_1_1AlignedBuffer.md#function-bencode)**([llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) const |
| bool | **[BDecode](Classes/structllarp_1_1AlignedBuffer.md#function-bdecode)**([llarp_buffer_t](Classes/structllarp__buffer__t.md) * buf) |
| std::string | **[ToHex](Classes/structllarp_1_1AlignedBuffer.md#function-tohex)**() const |
| std::string | **[ShortHex](Classes/structllarp_1_1AlignedBuffer.md#function-shorthex)**() const |
| bool | **[FromHex](Classes/structllarp_1_1AlignedBuffer.md#function-fromhex)**(std::string_view str) |
| constexpr size_t | **[size](Classes/structllarp_1_1AlignedBuffer.md#function-size)**() |

**Public Attributes inherited from [llarp::AlignedBuffer< PUBKEYSIZE >](Classes/structllarp_1_1AlignedBuffer.md)**

|                | Name           |
| -------------- | -------------- |
| constexpr auto | **[SIZE](Classes/structllarp_1_1AlignedBuffer.md#variable-size)**  |


## Public Functions Documentation

### function PubKey

```cpp
PubKey() =default
```


### function PubKey

```cpp
inline explicit PubKey(
    const byte_t * ptr
)
```


### function PubKey

```cpp
inline explicit PubKey(
    const Data & data
)
```


### function PubKey

```cpp
inline explicit PubKey(
    const AlignedBuffer< SIZE > & other
)
```


### function ToString

```cpp
std::string ToString() const
```


### function FromString

```cpp
bool FromString(
    const std::string & str
)
```


### function operator RouterID

```cpp
inline operator RouterID() const
```


### function operator=

```cpp
inline PubKey & operator=(
    const byte_t * ptr
)
```


-------------------------------

Updated on 2023-04-27 at 04:17:17 +0000